Page MenuHomeVyOS Platform

DHCPv6 is broken
Closed, ResolvedPublicBUG

Description

I noticed the issue trying to assign an dhcpc6 after the work on T2265. Looking back at the code, the issue most likely exists before my involvement with VyOS.

I noticed that the vyatta-dhclient-hook was not v6 aware wand would overwrite the v4 ".leases" file.
I am not sure if this is really a problem, as I believe it may not be used by DHCP itself.

I have a patch part of T2265 included
https://github.com/vyos/vyos-1x/pull/326/commits/9758945876134794204eed3f5b168818e1588a0d

When running the program manually with "-d" the following "helpful" advice is provided:

root@vyos:/var/lib/dhcp# /sbin/dhclient -6 -nw -cf /var/lib/dhcp/dhclient_eth0.v6conf -pf /var/lib/dhcp/dhclient_eth0.v6pid -lf /var/lib/dhcp/dhclient_eth0.v6leases eth0 -d
Internet Systems Consortium DHCP Client 4.4.1
Copyright 2004-2018 Internet Systems Consortium.
All rights reserved.
For info, please visit https://www.isc.org/software/dhcp/

no link-local IPv6 address for eth0

If you think you have received this message due to a bug rather
than a configuration issue please read the section on submitting
bugs on either our web page at www.isc.org or in the README file
before submitting a bug.  These pages explain the proper
process and the information we find helpful for debugging.

exiting.

I found this help page from ISC: https://kb.isc.org/docs/aa-00368

As I have limited experience with setup up DHCP .. I stopped the investigation there in hope someone else can help.

Details

Difficulty level
Unknown (require assessment)
Version
202004101136
Why the issue appeared?
Will be filled on close
Is it a breaking change?
Unspecified (possibly destroys the router)

Event Timeline

jjakob added a subscriber: jjakob.EditedApr 10 2020, 9:50 PM

no link-local IPv6 address for eth0

IIRC vyos doesn't support setting link-local addresses on interfaces
through the CLI, though a IPv6 interface should get one by default by the
kernel (I may be mistaken, what does "ip addr" say?)

pasik added a subscriber: pasik.Apr 11 2020, 9:31 AM
thomas-mangin added a comment.EditedApr 11 2020, 9:59 AM
2: eth0: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc pfifo_fast state UP group default qlen 1000
    link/ether 08:00:27:d9:5b:04 brd ff:ff:ff:ff:ff:ff
    inet 10.0.2.15/24 brd 10.0.2.255 scope global dynamic eth0
       valid_lft 78872sec preferred_lft 78872sec
    inet6 fe80::a00:27ff:fed9:5b04/64 scope link
       valid_lft forever preferred_lft forever

link-local is there. I am unclear if the issue comes as there is no DHCPv6 on the link and then DHCP takes that it it should assign a link-local and fails. I would have assumed that not having a DHCPv6 server should not cause dhcpclient to fail but I could be wrong. If this is expected, then the solution may be to ignore failures of dhcpclient when no link-local IPv6 address for eth0 is provided back to prevent a disappearing DHCPv6 to affect the IPv4 setup of the interface.
`

c-po closed this task as Resolved.Apr 29 2020, 1:07 PM
c-po claimed this task.

Resolved with T2393

c-po moved this task from Need Triage to Finished on the VyOS 1.3 Equuleus board.May 21 2020, 5:26 PM